package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.entity.GraphConceptDetail;
import com.diagbot.entity.GraphConceptInfo;
import com.diagbot.entity.KlConcept;
import com.diagbot.entity.KlConceptCommon;
import com.diagbot.entity.KlConceptDetail;
import com.diagbot.entity.KlConceptStatic;
import com.diagbot.entity.KlDisease;
import com.diagbot.entity.KlLibraryInfo;
import com.diagbot.entity.KlRelation;
import com.diagbot.entity.KlRule;
import com.diagbot.entity.KlRuleBase;
import com.diagbot.entity.KlRuleCondition;
import com.diagbot.entity.node.ExportNode;
import com.diagbot.entity.node.ExportRelation;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.exception.CommonErrorCode;
import com.diagbot.exception.CommonException;
import com.diagbot.repository.ExportNodeRepository;
import com.diagbot.repository.ExportRelationRepository;
import com.diagbot.service.KlConceptCommonService;
import com.diagbot.service.KlConceptDetailService;
import com.diagbot.service.KlConceptService;
import com.diagbot.service.KlConceptStaticService;
import com.diagbot.service.KlDiseaseService;
import com.diagbot.service.KlLibraryInfoService;
import com.diagbot.service.KlRelationService;
import com.diagbot.service.KlRuleBaseService;
import com.diagbot.service.KlRuleConditionService;
import com.diagbot.service.KlRuleService;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.Cn2SpellUtil;
import com.diagbot.util.EntityUtil;
import com.diagbot.util.ExcelUtils;
import com.diagbot.util.ListUtil;
import com.diagbot.util.StringUtil;
import com.diagbot.vo.ImportDataVO;
import com.diagbot.vo.KlRuleAnalyVO;
import com.diagbot.vo.KlRuleConditionVO;
import com.diagbot.vo.TestAllVO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @author: gaodm
 * @time: 2021/1/21 9:34
 */
@Component
@Slf4j
public class ExportFacade {
    @Autowired
    private ExportNodeRepository exportNodeRepository;
    @Autowired
    private ExportRelationRepository exportRelationRepository;
    @Autowired
    @Qualifier("klConceptServiceImpl")
    private KlConceptService klConceptService;
    @Autowired
    @Qualifier("klLibraryInfoServiceImpl")
    private KlLibraryInfoService klLibraryInfoService;
    @Autowired
    @Qualifier("klConceptCommonServiceImpl")
    private KlConceptCommonService klConceptCommonService;
    @Autowired
    @Qualifier("klDiseaseServiceImpl")
    private KlDiseaseService klDiseaseService;
    @Autowired
    @Qualifier("klRelationServiceImpl")
    private KlRelationService klRelationService;
    @Autowired
    private TestFacade testFacade;
    @Autowired
    @Qualifier("klRuleServiceImpl")
    private KlRuleService klRuleService;
    @Autowired
    @Qualifier("klRuleBaseServiceImpl")
    private KlRuleBaseService klRuleBaseService;
    @Autowired
    @Qualifier("klRuleConditionServiceImpl")
    private KlRuleConditionService klRuleConditionService;
    @Autowired
    private GraphConceptInfoFacade graphConceptInfoFacade;
    @Autowired
    private GraphConceptDetailFacade graphConceptDetailFacade;
    @Autowired
    @Qualifier("klConceptStaticServiceImpl")
    private KlConceptStaticService klConceptStaticService;
    @Autowired
    @Qualifier("klConceptDetailServiceImpl")
    private KlConceptDetailService klConceptDetailService;

    public final static List<String> operatorList = new ArrayList<String>() {
        {
            add(">");
            add("＞");
            add("≥");
            add(">=");
            add("＞=");
            add("=");
            add("＜");
            add("<");
            add("<=");
            add("＜=");
            add("≤");
        }
    };
    public final static List<String> operator_eq = new ArrayList<String>() {
        {
            add("=");
        }
    };
    public final static List<String> operator_gt = new ArrayList<String>() {
        {
            add(">");
            add("＞");
        }
    };
    public final static List<String> operator_ge = new ArrayList<String>() {
        {
            add("≥");
            add(">=");
            add("＞=");
        }
    };
    public final static List<String> operator_lt = new ArrayList<String>() {
        {
            add("＜");
            add("<");
        }
    };
    public final static List<String> operator_le = new ArrayList<String>() {
        {
            add("<=");
            add("＜=");
            add("≤");
        }
    };


    public Boolean gdbExportNode() {
        //图谱数据节点处理
        graphNodeDeal();
        return true;
    }

    private void graphNodeDeal() {
        //疾病处理
        List<ExportNode> nodes = new ArrayList<>();
        nodes.clear();
        nodes = exportNodeRepository.getDisease();
        nodes.addAll(exportNodeRepository.getDisease2());
        import2MySql(nodes, 100);
        //药品通用名
        nodes.clear();
        nodes = exportNodeRepository.getDrug();
        import2MySql(nodes, 101);
        //药品剂型
        nodes.clear();
        nodes = exportNodeRepository.getDrugForm();
        import2MySql(nodes, 102);
        //症状
        nodes.clear();
        nodes = exportNodeRepository.getSymptom();
        import2MySql(nodes, 103);
        //体格检查结果
        nodes.clear();
        nodes = exportNodeRepository.getVital();
        import2MySql(nodes, 105);
        //手术和操作
        nodes.clear();
        nodes = exportNodeRepository.getOeration();
        import2MySql(nodes, 106);
        //实验室检查套餐
        nodes.clear();
        nodes = exportNodeRepository.getLisPackage();
        import2MySql(nodes, 107);
        //实验室检查子项目
        nodes.clear();
        nodes = exportNodeRepository.getLisItem();
        import2MySql(nodes, 108);
        //辅助检查项目
        nodes.clear();
        nodes = exportNodeRepository.getPacs();
        import2MySql(nodes, 109);
        //辅助检查子项目
        nodes.clear();
        nodes = exportNodeRepository.getPacsSubItem();
        import2MySql(nodes, 110);
        //辅助检查描述
        nodes.clear();
        nodes = exportNodeRepository.getPacsDesc();
        import2MySql(nodes, 111);
        //辅助检查结果
        nodes.clear();
        nodes = exportNodeRepository.getPacsResult();
        import2MySql(nodes, 112);
        //输血类型
        nodes.clear();
        nodes = exportNodeRepository.getTransfusion();
        import2MySql(nodes, 113);
        //科室
        nodes.clear();
        nodes = exportNodeRepository.getDept();
        import2MySql(nodes, 115);
        //性别
        nodes.clear();
        nodes = exportNodeRepository.getSex();
        import2MySql(nodes, 116);
        //其他过敏原
        nodes.clear();
        nodes = exportNodeRepository.getAllergen();
        import2MySql(nodes, 119);
        //医疗器械及物品
        nodes.clear();
        nodes = exportNodeRepository.getApparatus();
        import2MySql(nodes, 120);
        //药品化学物质类别
        nodes.clear();
        nodes = exportNodeRepository.getDrugTypeA();
        import2MySql(nodes, 301);
        //药品治疗学类别
        nodes.clear();
        nodes = exportNodeRepository.getDrugTypeB();
        import2MySql(nodes, 302);
        //药品药理学类别
        nodes.clear();
        nodes = exportNodeRepository.getDrugTypeC();
        import2MySql(nodes, 303);
        //药品解剖学类别
        nodes.clear();
        nodes = exportNodeRepository.getDrugTypeD();
        import2MySql(nodes, 304);
    }

    private void import2MySql(List<ExportNode> nodes, Integer type) {
        List<KlLibraryInfo> libraryInfos = new ArrayList<>();
        List<String> names = new ArrayList<>();
        List<ExportNode> importNodes = new ArrayList<>();
        klLibraryInfoService.remove(new QueryWrapper<KlLibraryInfo>().eq("type_id", type));
        klConceptService.remove(new QueryWrapper<KlConcept>().eq("lib_type", type));
        for (ExportNode exportNode : nodes) {
            if (StringUtil.isNotBlank(exportNode.getName())
                    && !names.contains(exportNode.getName())) {
                KlLibraryInfo klLibraryInfo = new KlLibraryInfo();
                klLibraryInfo.setName(exportNode.getName());
                klLibraryInfo.setIsConcept(1);
                klLibraryInfo.setTypeId(type);
                klLibraryInfo.setSpell(Cn2SpellUtil.converterToFirstSpell(exportNode.getName()));
                libraryInfos.add(klLibraryInfo);
                names.add(exportNode.getName());
                importNodes.add(exportNode);
            }

        }
        klLibraryInfoService.saveBatch(libraryInfos);
        List<KlConcept> klConcepts = new ArrayList<>();
        for (KlLibraryInfo klLibraryInfo : libraryInfos) {
            KlConcept klConcept = new KlConcept();
            klConcept.setLibId(klLibraryInfo.getId());
            klConcept.setLibName(klLibraryInfo.getName());
            klConcept.setLibType(type);
            klConcepts.add(klConcept);
        }
        klConceptService.saveBatch(klConcepts);
        Map<Long, KlConcept> map = EntityUtil.makeEntityMap(klConcepts, "libId");
        for (KlLibraryInfo klLibraryInfo : libraryInfos) {
            klLibraryInfo.setConceptId(map.get(klLibraryInfo.getId()).getId());
        }
        klLibraryInfoService.updateBatchById(libraryInfos);
        if (type.equals(100)) {
            klConceptCommonService.remove(new QueryWrapper<KlConceptCommon>().eq("is_deleted", IsDeleteEnum.N.getKey()));
            klDiseaseService.remove(new QueryWrapper<KlDisease>().eq("is_deleted", IsDeleteEnum.N.getKey()));
            Map<String, ExportNode> nodeMap = EntityUtil.makeEntityMap(importNodes, "name");
            List<KlConceptCommon> klConceptCommons = new ArrayList<>();
            List<KlDisease> klDiseases = new ArrayList<>();
            for (KlConcept klConcept : klConcepts) {
                KlConceptCommon klConceptCommon = new KlConceptCommon();
                klConceptCommon.setConceptId(klConcept.getId());
                KlDisease klDisease = new KlDisease();
                klDisease.setConceptId(klConcept.getId());
                ExportNode exportNode = nodeMap.get(klConcept.getLibName());
                if (null != exportNode) {
                    klConceptCommon.setSexType(Integer.valueOf(exportNode.getSex()));
                    String[] age = exportNode.getAgeRange().split("-");
                    klConceptCommon.setMinAge(Double.valueOf(age[0]));
                    klConceptCommon.setMaxAge(Double.valueOf(age[1]));
                    klConceptCommons.add(klConceptCommon);
                    if (StringUtil.isNotBlank(exportNode.getIcd10Code())) {
                        klDisease.setIcd10Code(exportNode.getIcd10Code());
                        klDiseases.add(klDisease);
                    }
                }
            }
            klConceptCommonService.saveBatch(klConceptCommons);
            klDiseaseService.saveBatch(klDiseases);
        }
    }

    public Boolean gdbExportRelation() {
        //图谱关系处理
        graphRelationDeal();
        return true;
    }

    private void graphRelationDeal() {
        //获取标准词库Map
        Map<String, KlConcept> map = getConceptMap();
        //药品化学物质类别树形结构
        List<ExportRelation> exportRelations = exportRelationRepository.getDrugRelationA();
        import2MySqlR(exportRelations, 301, 101, map);
        //药品治疗学类别树形结构
        exportRelations.clear();
        exportRelations = exportRelationRepository.getDrugRelationB();
        import2MySqlR(exportRelations, 302, 101, map);
        //药品药理学类别树形结构
        exportRelations.clear();
        exportRelations = exportRelationRepository.getDrugRelationC();
        import2MySqlR(exportRelations, 303, 101, map);
        //药品解剖学类别树形结构
        exportRelations.clear();
        exportRelations = exportRelationRepository.getDrugRelationD();
        import2MySqlR(exportRelations, 304, 101, map);
        //实验室检查类别树形结构
        exportRelations.clear();
        exportRelations = exportRelationRepository.getLisRelation();
        import2MySqlR(exportRelations, 107, 108, map);
        //辅助检查类别树形结构
        exportRelations.clear();
        exportRelations = exportRelationRepository.getPacsRelation();
        import2MySqlR(exportRelations, 109, 110, map);
    }

    private void import2MySqlR(List<ExportRelation> exportRelations, Integer stype, Integer etype, Map<String, KlConcept> map) {
        import2MySqlR(exportRelations, stype, etype, 600, map);
    }

    private void import2MySqlR(List<ExportRelation> exportRelations, Integer stype, Integer etype, Integer rType, Map<String, KlConcept> map) {
        List<KlRelation> klRelations = new ArrayList<>();
        for (ExportRelation exportRelation : exportRelations) {
            if (null != map.get(exportRelation.getSname() + "_" + stype)
                    && null != map.get(exportRelation.getEname() + "_" + etype)) {
                KlRelation klRelation = new KlRelation();
                klRelation.setStartId(map.get(exportRelation.getSname() + "_" + stype).getId());
                klRelation.setEndId(map.get(exportRelation.getEname() + "_" + etype).getId());
                klRelation.setRelationId(rType);
                klRelations.add(klRelation);
            }
        }
        klRelationService.saveBatch(klRelations);
    }

    public Map<String, Object> importExcelGraphDB() {
        graphRelationDealdiagnose();
        return null;
    }

    private void graphRelationDealdiagnose() {
        //获取标准词库Map
        Map<String, KlConcept> map = getConceptMap();
        //主症状
        List<ExportRelation> exportRelations = exportRelationRepository.symptomMainPush();
        import2MySqlR(exportRelations, 100, 103, 501, map);
        //次症状
        exportRelations.clear();
        exportRelations = exportRelationRepository.symptomSecPush();
        import2MySqlR(exportRelations, 100, 103, 502, map);
        //体格检查结果
        exportRelations.clear();
        exportRelations = exportRelationRepository.vitalPush();
        import2MySqlR(exportRelations, 100, 105, 503, map);
        //实验室检查套餐
        exportRelations.clear();
        exportRelations = exportRelationRepository.lisPush();
        import2MySqlR(exportRelations, 100, 107, 504, map);
        //辅助检查项目
        exportRelations.clear();
        exportRelations = exportRelationRepository.pacsPush();
        import2MySqlR(exportRelations, 100, 109, 505, map);
        //药品通用名
        exportRelations.clear();
        exportRelations = exportRelationRepository.drugPush();
        import2MySqlR(exportRelations, 100, 101, 506, map);
        //手术和操作
        exportRelations.clear();
        exportRelations = exportRelationRepository.operationPush();
        import2MySqlR(exportRelations, 100, 106, 507, map);
        //鉴别诊断
        exportRelations.clear();
        exportRelations = exportRelationRepository.diffDiagnosePush();
        import2MySqlR(exportRelations, 100, 100, 508, map);
    }

    public Map<String, Object> importExcel(MultipartFile file) {
        List<ImportDataVO> data = ExcelUtils.importExcel(file, 0, 1, ImportDataVO.class);
        //获取标准词库Map
        Map<String, KlConcept> map = getConceptMap();
        List<KlRelation> klRelations = new ArrayList<>();
        List<String> relations = new ArrayList<>();
        for (ImportDataVO importDataVO : data) {
            //主症状
            setKlRelations(importDataVO.getDiseasePush(), importDataVO.getSymptomMainPush(), 100, 103, 501, map, klRelations, relations);
            //次症状
            setKlRelations(importDataVO.getDiseasePush(), importDataVO.getSymptomSecPush(), 100, 103, 502, map, klRelations, relations);
            //体格检查结果
            setKlRelations(importDataVO.getDiseasePush(), importDataVO.getVitalPush(), 100, 105, 503, map, klRelations, relations);
            //实验室检查套餐
            setKlRelations(importDataVO.getDiseasePush(), importDataVO.getLisPush(), 100, 107, 504, map, klRelations, relations);
            //辅助检查项目
            setKlRelations(importDataVO.getDiseasePush(), importDataVO.getPacsPush(), 100, 109, 505, map, klRelations, relations);
            //辅助检查子项目
            setKlRelations(importDataVO.getDiseasePush(), importDataVO.getPacsPush(), 100, 110, 505, map, klRelations, relations);
            //药品通用名
            setKlRelations(importDataVO.getDiseasePush(), importDataVO.getDrugPush(), 100, 101, 506, map, klRelations, relations);
            //手术和操作
            setKlRelations(importDataVO.getDiseasePush(), importDataVO.getOperationPush(), 100, 106, 507, map, klRelations, relations);
        }
        klRelationService.saveBatch(klRelations);
        return null;
    }

    private void setKlRelations(String startStr, String endStr, Integer stype, Integer etype, Integer rtype,
                                Map<String, KlConcept> map, List<KlRelation> klRelations, List<String> relations) {
        if (StringUtil.isNotBlank(startStr)
                && StringUtil.isNotBlank(endStr)) {
            List<String> ends = Arrays.asList(endStr.replaceAll("；", ";").split(";"));
            for (String s : ends) {
                if (null != map.get(startStr + "_" + stype)
                        && null != map.get(s + "_" + etype)) {
                    KlRelation klRelation = new KlRelation();
                    klRelation.setStartId(map.get(startStr.trim() + "_" + stype).getId());
                    klRelation.setEndId(map.get(s.trim() + "_" + etype).getId());
                    klRelation.setRelationId(rtype);
                    String r = map.get(startStr.trim() + "_" + stype).getId() + "_" + rtype + "_" + map.get(s.trim() + "_" + etype).getId();
                    if (!relations.contains(r)) {
                        relations.add(r);
                        klRelations.add(klRelation);
                    }

                }
            }
        }
    }

    public Map<String, Object> importExcelTip(TestAllVO testAllVO) {
        if (StringUtil.isBlank(testAllVO.getPath())) {
            throw new CommonException(CommonErrorCode.SERVER_IS_ERROR, "参数为空，未填写【文件所在路径】");
        }
        String path = testAllVO.getPath();
        Map<String, Object> paramMap = new LinkedHashMap<>();
        Map<String, String> mapPath = new LinkedHashMap<>();
        mapPath.put("【危急值_化验】", path + File.separator + "【危急值_化验】.xlsx");
        mapPath.put("【危急值_辅检】", path + File.separator + "【危急值_辅检】.xlsx");
        mapPath.put("【其他值提醒_化验】", path + File.separator + "【其他值提醒_化验】.xlsx");
        mapPath.put("【其他值提醒_辅检】", path + File.separator + "【其他值提醒_辅检】.xlsx");
        mapPath.put("【其他值提醒_输血】", path + File.separator + "【其他值提醒_输血】.xlsx");
        mapPath.put("【高危药品】", path + File.separator + "【高危药品】.xlsx");
        mapPath.put("【高危手术整合】", path + File.separator + "【高危手术整合】.xlsx");
        mapPath.put("【开单合理性】", path + File.separator + "【开单合理性】.xlsx");
        mapPath.put("【开单合理性_输血】", path + File.separator + "【开单合理性_输血】.xlsx");
        mapPath.put("【检查结果与项目重复开立规则】", path + File.separator + "【检查结果与项目重复开立规则】.xlsx");
        paramMap.put("mapPath", mapPath);
        //获取标准词库Map
        Map<String, KlConcept> map = getConceptMap();
        //开单合理性(除输血外)
        allOrder(mapPath, map);
        //开单合理性_输血
        transfusionOrder(mapPath, map);
        //高危药品
        drugHighRisk(mapPath, map);
        //高危手术
        optHighRisk(mapPath, map);
        //危急值化验
        lisCriticalValues(mapPath, map);
        //危急值辅检
        pacsCriticalValues(mapPath, map);
        //其他值提醒_化验
        lisOtherValues(mapPath, map);
        //其他值提醒_辅检
        pacsOtherValues(mapPath, map);
        //其他值提醒_输血
        transfusionOtherValues(mapPath, map);
        //检查结果与项目重复开立规则
        pacsReorder(mapPath, map);
        return null;
    }

    private void allOrder(Map<String, String> mapPath, Map<String, KlConcept> map) {
        MultipartFile file = null;
        file = testFacade.getMulFileByPath(mapPath.get("【开单合理性】"));
        List<ImportDataVO> data = ExcelUtils.importExcel(file, 0, 1, ImportDataVO.class);
        Integer cnt = 0;
        String debug = "";
        for (ImportDataVO importDataVO : data) {
            if (StringUtil.isNotBlank(importDataVO.getStandName())
                    && StringUtil.isNotBlank(importDataVO.getOrderType())
                    && StringUtil.isNotBlank(importDataVO.getNeoName())
                    && StringUtil.isNotBlank(importDataVO.getNeoType())
                    && StringUtil.isNotBlank(importDataVO.getOrderType())
                    && !importDataVO.getOrderType().equals("联合项目")
                    && StringUtil.isBlank(importDataVO.getStatus())) {
                //                if (!importDataVO.getNeoType().equals("7")) {
                //                    continue;
                //                }
                if (importDataVO.getNeoType().equals("7")) {
                    if (importDataVO.getNeoName().trim().equals("本品成份")
                            || importDataVO.getNeoName().trim().equals("本品的成分")
                            || importDataVO.getNeoName().trim().equals("本品任何成分")
                            || importDataVO.getNeoName().trim().equals("本品中任何成分")
                            || importDataVO.getNeoName().trim().equals("本品中任何成份过敏")) {
                        continue;
                    }
                }
                if (importDataVO.getNeoType().equals("15")) {
                    //给药途径无法处理
                    continue;
                }
                KlRule klRule = new KlRule();
                Boolean canInsert = false;
                switch (importDataVO.getOrderType()) {
                    case "辅助检查名称":
                    case "辅助检查子项目名称":
                    case "辅助子项目检查名称":
                        if (null != map.get(importDataVO.getStandName().trim() + "_109")) {
                            klRule.setConceptId(map.get(importDataVO.getStandName().trim() + "_109").getId());
                            klRule.setDescription("开单合理性_辅助检查项目_" + importDataVO.getStandName().trim());
                            canInsert = true;
                        } else {
                            if (null != map.get(importDataVO.getStandName().trim() + "_110")) {
                                klRule.setConceptId(map.get(importDataVO.getStandName().trim() + "_110").getId());
                                klRule.setDescription("开单合理性_辅助检查子项目_" + importDataVO.getStandName().trim());
                                canInsert = true;
                            } else {
                                debug += importDataVO.getStandName().trim() + "," + importDataVO.getOrderType() + ";";
                            }
                        }
                        break;
                    case "实验室检查套餐":
                    case "实验室检查套餐名":
                        if (null != map.get(importDataVO.getStandName().trim() + "_107")) {
                            klRule.setConceptId(map.get(importDataVO.getStandName().trim() + "_107").getId());
                            klRule.setDescription("开单合理性_实验室检查套餐_" + importDataVO.getStandName().trim());
                            canInsert = true;
                        } else {
                            debug += importDataVO.getStandName().trim() + "," + importDataVO.getOrderType() + ";";
                        }
                        break;
                    case "药品通用名称":
                        if (null != map.get(importDataVO.getStandName().trim() + "_101")) {
                            klRule.setConceptId(map.get(importDataVO.getStandName().trim() + "_101").getId());
                            klRule.setDescription("开单合理性_实验室检查套餐_" + importDataVO.getStandName().trim());
                            canInsert = true;
                        } else {
                            debug += importDataVO.getStandName().trim() + "," + importDataVO.getOrderType() + ";";
                        }
                        break;
                    case "医保手术和操作名称":
                        if (null != map.get(importDataVO.getStandName().trim() + "_106")) {
                            klRule.setConceptId(map.get(importDataVO.getStandName().trim() + "_106").getId());
                            klRule.setDescription("开单合理性_手术药品_" + importDataVO.getStandName().trim());
                            canInsert = true;
                        } else {
                            debug += importDataVO.getStandName().trim() + "," + importDataVO.getOrderType() + ";";
                        }
                        break;
                }
                if (canInsert) {
                    klRule.setRuleType(1);
                    klRule.setHasSubCond(1);
                    klRuleService.save(klRule);
                    cnt++;
                    Boolean baseCanInsert = false;
                    KlRuleBase klRuleBase = new KlRuleBase();
                    //1性别，2实验室检查，3临床表现，4辅助检查名称描述，5疾病，6服用药品，
                    //7药物过敏原，8食物过敏原，9手术，10禁忌人群，11过敏原，12体征，
                    //13禁忌医疗器械及物品，14年龄，15给药途径，16开单项互斥
                    switch (importDataVO.getNeoType().trim()) {
                        case "1":
                            //1性别
                            if (null != map.get(importDataVO.getNeoName().trim() + "_116")) {
                                klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_116").getId());
                                klRuleBase.setDescription("性别_" + importDataVO.getNeoName().trim());
                                klRuleBase.setType(1);
                                baseCanInsert = true;
                            } else {
                                debug += importDataVO.getNeoName().trim() + ",1性别;";
                            }
                            break;
                        case "2":
                            //2实验室检查
                            baseCanInsert = strDeal(importDataVO, klRuleBase, map, debug, 108, ",2实验室检查;");
                            break;
                        case "3":
                            //3临床表现
                            if (null != map.get(importDataVO.getNeoName().trim() + "_103")) {
                                klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_103").getId());
                                klRuleBase.setDescription("临床表现_" + importDataVO.getNeoName().trim());
                                klRuleBase.setType(1);
                                baseCanInsert = true;
                            } else {
                                debug += importDataVO.getNeoName().trim() + ",3临床表现;";
                            }
                            break;
                        case "4":
                            //4辅助检查名称描述
                            if (null != map.get(importDataVO.getNeoName().trim() + "_112")) {
                                klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_112").getId());
                                klRuleBase.setDescription("辅助检查名称描述_" + importDataVO.getNeoName().trim());
                                klRuleBase.setType(1);
                                baseCanInsert = true;
                            } else {
                                debug += importDataVO.getNeoName().trim() + ",4辅助检查名称描述;";
                            }
                            break;
                        case "5":
                            //5疾病
                            if (null != map.get(importDataVO.getNeoName().trim() + "_100")) {
                                klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_100").getId());
                                klRuleBase.setDescription("疾病_" + importDataVO.getNeoName().trim());
                                klRuleBase.setType(1);
                                baseCanInsert = true;
                            } else {
                                debug += importDataVO.getNeoName().trim() + ",5疾病;";
                            }
                            break;
                        case "6":
                            //6服用药品
                            if (null != map.get(importDataVO.getNeoName().trim() + "_101")) {
                                klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_101").getId());
                                klRuleBase.setDescription("服用药品_" + importDataVO.getNeoName().trim());
                                klRuleBase.setType(1);
                                baseCanInsert = true;
                            } else {
                                debug += importDataVO.getNeoName().trim() + ",6服用药品;";
                            }
                            break;
                        case "7":
                            //7药物过敏原
                            if (importDataVO.getDrugType().trim().equals("药品类别")) {
                                if (null != map.get(importDataVO.getNeoName().trim() + "_301")
                                        || null != map.get(importDataVO.getNeoName().trim() + "_302")
                                        || null != map.get(importDataVO.getNeoName().trim() + "_303")
                                        || null != map.get(importDataVO.getNeoName().trim() + "_304")) {
                                    if (null != map.get(importDataVO.getNeoName().trim() + "_301")) {
                                        klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_301").getId());
                                    } else if (null != map.get(importDataVO.getNeoName().trim() + "_302")) {
                                        klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_302").getId());
                                    } else if (null != map.get(importDataVO.getNeoName().trim() + "_303")) {
                                        klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_303").getId());
                                    } else {
                                        klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_304").getId());
                                    }
                                    klRuleBase.setDescription("药物过敏原_" + importDataVO.getDrugType() + "_" + importDataVO.getNeoName().trim());
                                    klRuleBase.setType(4);
                                    baseCanInsert = true;
                                } else {
                                    debug += importDataVO.getNeoName().trim() + ",7药物过敏原(" + importDataVO.getDrugType() + ");";
                                }

                            } else {
                                if (null != map.get(importDataVO.getNeoName().trim() + "_101")) {
                                    klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_101").getId());
                                    klRuleBase.setDescription("药物过敏原_" + importDataVO.getDrugType() + "_" + importDataVO.getNeoName().trim());
                                    klRuleBase.setType(4);
                                    baseCanInsert = true;
                                } else {
                                    debug += importDataVO.getNeoName().trim() + ",7药物过敏原(" + importDataVO.getDrugType() + ");";
                                }
                            }
                            break;
                        case "8":
                            //8食物过敏原
                            if (null != map.get(importDataVO.getNeoName().trim() + "_118")) {
                                klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_118").getId());
                                klRuleBase.setDescription("食物过敏原_" + importDataVO.getNeoName().trim());
                                klRuleBase.setType(4);
                                baseCanInsert = true;
                            } else {
                                debug += importDataVO.getNeoName().trim() + ",8食物过敏原;";
                            }
                            break;
                        case "9":
                            //9手术
                            if (null != map.get(importDataVO.getNeoName().trim() + "_106")) {
                                klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_106").getId());
                                klRuleBase.setDescription("手术_" + importDataVO.getNeoName().trim());
                                klRuleBase.setType(1);
                                baseCanInsert = true;
                            } else {
                                debug += importDataVO.getNeoName().trim() + ",9手术;";
                            }
                            break;
                        case "10":
                            //10禁忌人群
                            if (null != map.get(importDataVO.getNeoName().trim().replace("，", "") + "_117")) {
                                klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim().replace("，", "") + "_117").getId());
                                klRuleBase.setDescription("禁忌人群_" + importDataVO.getNeoName().trim().replace("，", ""));
                                klRuleBase.setType(1);
                                baseCanInsert = true;
                            } else {
                                debug += importDataVO.getNeoName().trim() + ",10禁忌人群;";
                            }
                            break;
                        case "11":
                            //11过敏原
                            if (null != map.get(importDataVO.getNeoName().trim() + "_119")) {
                                klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_119").getId());
                                klRuleBase.setDescription("过敏原_" + importDataVO.getNeoName().trim());
                                klRuleBase.setType(4);
                                baseCanInsert = true;
                            } else {
                                debug += importDataVO.getNeoName().trim() + ",11过敏原;";
                            }
                            break;
                        case "12":
                            //12体征
                            if (null != map.get(importDataVO.getNeoName().trim() + "_105")) {
                                klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_105").getId());
                                klRuleBase.setDescription("体征_" + importDataVO.getNeoName().trim());
                                klRuleBase.setType(1);
                                baseCanInsert = true;
                            } else {
                                baseCanInsert = strDeal(importDataVO, klRuleBase, map, debug, 104, ",12体征;");
                            }
                            break;
                        case "13":
                            //13禁忌医疗器械及物品
                            if (null != map.get(importDataVO.getNeoName().trim() + "_120")) {
                                klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_120").getId());
                                klRuleBase.setDescription("禁忌医疗器械及物品_" + importDataVO.getNeoName().trim());
                                klRuleBase.setType(1);
                                baseCanInsert = true;
                            } else {
                                debug += importDataVO.getNeoName().trim() + ",13禁忌医疗器械及物品;";
                            }
                            break;
                        case "14":
                            //14年龄
                            baseCanInsert = strDeal(importDataVO, klRuleBase, map, debug, 410, ",14年龄;");
                            break;
                        case "15":
                            //15给药途径
                            //数据暂时不导入
                            break;
                        case "16":
                            //16开单项互斥
                            if (null != map.get(importDataVO.getNeoName().trim() + "_109")) {
                                klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_109").getId());
                                klRuleBase.setDescription("开单项互斥_" + importDataVO.getNeoName().trim());
                                klRuleBase.setType(5);
                                baseCanInsert = true;
                            } else {
                                debug += importDataVO.getNeoName().trim() + ",16开单项互斥;";
                            }
                            break;
                    }
                    if (baseCanInsert) {
                        klRuleBaseService.save(klRuleBase);
                        KlRuleCondition klRuleCondition = new KlRuleCondition();
                        klRuleCondition.setGroupType(1);
                        klRuleCondition.setRuleId(klRule.getId());
                        klRuleCondition.setRuleBaseId(klRuleBase.getId());
                        klRuleConditionService.save(klRuleCondition);
                    }
                }
            }
        }
        log.info("总条数：" + cnt);
        log.info(debug);
    }

    private Boolean strDeal(ImportDataVO importDataVO, KlRuleBase klRuleBase, Map<String, KlConcept> map,
                            String debug, Integer type, String debugStr) {
        Boolean baseCanInsert = false;
        List<String> slist = Arrays.asList(importDataVO.getNeoName().split("，"));
        KlRuleConditionVO klRuleConditionVO = new KlRuleConditionVO();
        if (slist.size() == 0) {
            klRuleBase.setType(1);
            if (null != map.get(importDataVO.getNeoName().trim() + "_" + type)) {
                klRuleBase.setConceptId(map.get(importDataVO.getNeoName().trim() + "_" + type).getId());
                klRuleBase.setDescription(importDataVO.getNeoName().trim());
                klRuleBase.setType(1);
                baseCanInsert = true;
            } else {
                debug += importDataVO.getNeoName().trim() + debugStr;
            }
            return baseCanInsert;
        }
        if (slist.size() == 4) {
            klRuleConditionVO.setName(slist.get(0));
            klRuleConditionVO.setOperator(slist.get(1));
            klRuleConditionVO.setValue(slist.get(2));
            klRuleConditionVO.setUnit(slist.get(3));
        } else if (slist.size() == 3) {
            klRuleConditionVO.setName(slist.get(0));
            klRuleConditionVO.setOperator(slist.get(1));
            klRuleConditionVO.setValue(slist.get(2));
            klRuleConditionVO.setUnit("");
        } else if (slist.size() == 2) {
            klRuleConditionVO.setName(slist.get(0));
            klRuleConditionVO.setOperator("=");
            klRuleConditionVO.setValue(slist.get(1));
            klRuleConditionVO.setUnit("");
        } else {

        }
        klRuleBase.setType(2);
        if (null != map.get(klRuleConditionVO.getName() + "_" + type)) {
            klRuleBase.setConceptId(map.get(klRuleConditionVO.getName().trim() + "_" + type).getId());
            klRuleBase.setDescription(klRuleConditionVO.getName()
                    + klRuleConditionVO.getOperator()
                    + klRuleConditionVO.getValue()
                    + " "
                    + klRuleConditionVO.getUnit());
            if (operator_eq.contains(klRuleConditionVO.getOperator())) {
                klRuleBase.setEqOperator("=");
                klRuleBase.setEqValue(klRuleConditionVO.getValue());
                klRuleBase.setEqUnit(klRuleConditionVO.getUnit());
            } else if (operator_gt.contains(klRuleConditionVO.getOperator())) {
                klRuleBase.setMinOperator(">");
                klRuleBase.setMinValue(klRuleConditionVO.getValue());
                klRuleBase.setMinUnit(klRuleConditionVO.getUnit());
            } else if (operator_ge.contains(klRuleConditionVO.getOperator())) {
                klRuleBase.setMinOperator(">=");
                klRuleBase.setMinValue(klRuleConditionVO.getValue());
                klRuleBase.setMinUnit(klRuleConditionVO.getUnit());
            } else if (operator_lt.contains(klRuleConditionVO.getOperator())) {
                klRuleBase.setMaxOperator("<");
                klRuleBase.setMaxValue(klRuleConditionVO.getValue());
                klRuleBase.setMaxUnit(klRuleConditionVO.getUnit());
            } else if (operator_le.contains(klRuleConditionVO.getOperator())) {
                klRuleBase.setMaxOperator("<=");
                klRuleBase.setMaxValue(klRuleConditionVO.getValue());
                klRuleBase.setMaxUnit(klRuleConditionVO.getUnit());
            } else {
                /*DO Nothing*/
            }
            baseCanInsert = true;
        } else {
            debug += klRuleConditionVO.getName() + debugStr;
        }
        return baseCanInsert;
    }

    private void transfusionOrder(Map<String, String> mapPath, Map<String, KlConcept> map) {
        MultipartFile file = null;
        file = testFacade.getMulFileByPath(mapPath.get("【开单合理性_输血】"));
        List<ImportDataVO> data = ExcelUtils.importExcel(file, 0, 1, ImportDataVO.class);
        for (ImportDataVO importDataVO : data) {
            if (null != map.get(importDataVO.getTransfusionName() + "_113")
                    && StringUtil.isNotBlank(importDataVO.getTransfusionNodeName())
                    && StringUtil.isNotBlank(importDataVO.getStandName())) {
                KlRule klRule = new KlRule();
                klRule.setConceptId(map.get(importDataVO.getTransfusionName() + "_113").getId());
                klRule.setDescription("开单合理性_输血_" + importDataVO.getTransfusionName().trim());
                klRule.setRuleType(1);
                klRule.setHasSubCond(1);
                klRuleService.save(klRule);
                if (StringUtil.isNotBlank(importDataVO.getTransfusionNodeName())
                        && StringUtil.isNotBlank(importDataVO.getStandName())) {
                    KlRuleBase klRuleBase = new KlRuleBase();
                    if (importDataVO.getTransfusionNodeName().equals("实验室检查")) {
                        klRuleBase.setConceptId(map.get(importDataVO.getStandName() + "_108").getId());
                        if (operator_lt.contains(importDataVO.getSymbol())) {
                            klRuleBase.setType(2);
                            klRuleBase.setMaxOperator("<");
                            klRuleBase.setMaxValue(importDataVO.getValue().toString());
                            if (StringUtil.isNotBlank(importDataVO.getUnit())) {
                                klRuleBase.setMaxUnit(importDataVO.getUnit().trim());
                            }
                        }
                        if (operator_gt.contains(importDataVO.getSymbol())) {
                            klRuleBase.setType(2);
                            klRuleBase.setMinOperator(">");
                            klRuleBase.setMinValue(importDataVO.getValue().toString());
                            if (StringUtil.isNotBlank(importDataVO.getUnit())) {
                                klRuleBase.setMinUnit(importDataVO.getUnit().trim());
                            }
                        }
                        if (StringUtil.isNotBlank(importDataVO.getUnit())) {
                            klRuleBase.setDescription("检验_" + importDataVO.getStandName() + importDataVO.getSymbol()
                                    + importDataVO.getValue() + " " + importDataVO.getUnit());
                        } else {
                            klRuleBase.setDescription("检验_" + importDataVO.getStandName() + importDataVO.getSymbol()
                                    + importDataVO.getValue());
                        }
                    } else if (importDataVO.getTransfusionNodeName().equals("医保疾病名称")) {
                        klRuleBase.setConceptId(map.get(importDataVO.getStandName() + "_100").getId());
                        klRuleBase.setType(1);
                        klRuleBase.setDescription("疾病_" + importDataVO.getStandName());
                    } else if (importDataVO.getTransfusionNodeName().equals("手术和操作")) {
                        klRuleBase.setConceptId(map.get(importDataVO.getStandName() + "_106").getId());
                        klRuleBase.setType(1);
                        klRuleBase.setDescription("手术和操作_" + importDataVO.getStandName());
                    } else {

                    }
                    klRuleBaseService.save(klRuleBase);
                    KlRuleCondition klRuleCondition = new KlRuleCondition();
                    klRuleCondition.setGroupType(1);
                    klRuleCondition.setRuleId(klRule.getId());
                    klRuleCondition.setRuleBaseId(klRuleBase.getId());
                    klRuleConditionService.save(klRuleCondition);
                }
            }
        }
    }

    private void lisCriticalValues(Map<String, String> mapPath, Map<String, KlConcept> map) {
        MultipartFile file = null;
        file = testFacade.getMulFileByPath(mapPath.get("【危急值_化验】"));
        List<ImportDataVO> data = ExcelUtils.importExcel(file, 0, 1, ImportDataVO.class);
        List<String> lis = new ArrayList<>();
        for (ImportDataVO importDataVO : data) {
            if (StringUtil.isNotBlank(importDataVO.getLisGBName())) {
                String lisStr = importDataVO.getLisGBName().trim();
                if (StringUtil.isNotBlank(importDataVO.getCriticalAge())) {
                    lisStr = lisStr + "_" + importDataVO.getCriticalAge().trim();
                }
                if (!lis.contains(lisStr)
                        && (null != map.get(importDataVO.getLisGBName().trim() + "_108"))) {
                    lis.add(lisStr);
                    KlRule klRule = new KlRule();
                    klRule.setConceptId(map.get(importDataVO.getLisGBName().trim() + "_108").getId());
                    klRule.setDescription("危急值_化验_" + lisStr);
                    klRule.setRuleType(3);
                    klRule.setHasSubCond(1);
                    klRuleService.save(klRule);
                    KlRuleBase klRuleBase = new KlRuleBase();
                    klRuleBase.setConceptId(map.get(importDataVO.getLisGBName().trim() + "_108").getId());
                    klRuleBase.setDescription("比较条件:" + importDataVO.getLisGBName().trim());
                    if (null != importDataVO.getCriticalMin()) {
                        klRuleBase.setType(2);
                        klRuleBase.setMinOperator(">=");
                        klRuleBase.setMinValue(importDataVO.getCriticalMin().toString());
                        if (StringUtil.isNotBlank(importDataVO.getUnit())) {
                            klRuleBase.setMinUnit(importDataVO.getUnit().trim());
                        }
                    }
                    if (null != importDataVO.getCriticalMax()) {
                        klRuleBase.setType(2);
                        klRuleBase.setMaxOperator("<=");
                        klRuleBase.setMaxValue(importDataVO.getCriticalMax().toString());
                        if (StringUtil.isNotBlank(importDataVO.getUnit())) {
                            klRuleBase.setMaxUnit(importDataVO.getUnit().trim());
                        }
                    }
                    if (StringUtil.isNotBlank(importDataVO.getCriticalNegative())) {
                        klRuleBase.setType(2);
                        klRuleBase.setEqOperator("=");
                        klRuleBase.setEqValue(importDataVO.getCriticalNegative().trim());
                        if (StringUtil.isNotBlank(importDataVO.getUnit())) {
                            klRuleBase.setEqUnit(importDataVO.getUnit().trim());
                        }
                    }

                    klRuleBaseService.save(klRuleBase);
                    KlRuleCondition klRuleCondition = new KlRuleCondition();
                    klRuleCondition.setGroupType(1);
                    klRuleCondition.setRuleId(klRule.getId());
                    klRuleCondition.setRuleBaseId(klRuleBase.getId());
                    klRuleConditionService.save(klRuleCondition);


                    if (StringUtil.isNotBlank(importDataVO.getCriticalAge())) {
                        KlRuleBase klRuleBase2 = new KlRuleBase();
                        klRuleBase2.setConceptId(map.get(importDataVO.getCriticalAge().trim() + "_117").getId());
                        klRuleBase2.setDescription("参考对象:" + importDataVO.getCriticalAge().trim());
                        klRuleBase2.setType(1);
                        klRuleBaseService.save(klRuleBase2);
                        KlRuleCondition klRuleCondition2 = new KlRuleCondition();
                        klRuleCondition2.setGroupType(1);
                        klRuleCondition2.setRuleId(klRule.getId());
                        klRuleCondition2.setRuleBaseId(klRuleBase2.getId());
                        klRuleConditionService.save(klRuleCondition2);
                    }
                }
            }
        }
        log.info("危急值_化验" + lis.size());
    }

    private void pacsCriticalValues(Map<String, String> mapPath, Map<String, KlConcept> map) {
        MultipartFile file = null;
        file = testFacade.getMulFileByPath(mapPath.get("【危急值_辅检】"));
        List<ImportDataVO> data = ExcelUtils.importExcel(file, 0, 1, ImportDataVO.class);
        Integer cnt = 0;
        for (ImportDataVO importDataVO : data) {
            if (null != map.get(importDataVO.getRuleText().trim() + "_112")) {
                KlRule klRule = new KlRule();
                klRule.setConceptId(map.get(importDataVO.getRuleText().trim() + "_112").getId());
                klRule.setDescription("危急值_辅检_" + importDataVO.getRuleText().trim());
                klRule.setRuleType(3);
                klRule.setHasSubCond(0);
                klRuleService.save(klRule);
                cnt++;
            }
        }
        log.info("危急值_辅检" + cnt);
    }

    private void optHighRisk(Map<String, String> mapPath, Map<String, KlConcept> map) {
        MultipartFile file = null;
        file = testFacade.getMulFileByPath(mapPath.get("【高危手术整合】"));
        List<ImportDataVO> data = ExcelUtils.importExcel(file, 0, 1, ImportDataVO.class);
        List<String> opt = new ArrayList<>();
        for (ImportDataVO importDataVO : data) {
            if (StringUtil.isNotBlank(importDataVO.getOperationName())
                    && StringUtil.isNotBlank(importDataVO.getOperationLevel())) {
                if (null != map.get(importDataVO.getOperationName() + "_106").getId()
                        && !opt.contains(importDataVO.getOperationName().trim())) {
                    opt.add(importDataVO.getOperationName().trim());
                    KlRule klRule = new KlRule();
                    klRule.setConceptId(map.get(importDataVO.getOperationName().trim() + "_106").getId());
                    klRule.setDescription("高危手术_" + importDataVO.getOperationName().trim() + importDataVO.getOperationLevel().trim());
                    klRule.setRuleType(2);
                    if (importDataVO.getOperationLevel().trim().equals("2")) {
                        klRule.setHasSubCond(1);
                    } else if (importDataVO.getOperationLevel().trim().equals("3")
                            || importDataVO.getOperationLevel().trim().equals("4")) {
                        klRule.setHasSubCond(0);
                    } else {
                        continue;
                    }
                    klRuleService.save(klRule);
                    if (importDataVO.getOperationLevel().equals("2")) {
                        Integer groupType = 1;
                        if (StringUtil.isNotBlank(importDataVO.getAgeAll())) {
                            groupType = analyDataDeal(map, importDataVO.getAgeAll(), klRule.getId(), 410, groupType);
                        }
                        if (StringUtil.isNotBlank(importDataVO.getPhysique())) {
                            groupType = analyDataDeal(map, importDataVO.getPhysique(), klRule.getId(), 104, 105, groupType);
                        }
                        if (StringUtil.isNotBlank(importDataVO.getLisAll())) {
                            groupType = analyDataDeal(map, importDataVO.getLisAll(), klRule.getId(), 108, groupType);
                        }
                        if (StringUtil.isNotBlank(importDataVO.getDisease())) {
                            groupType = analyDataDealSimple(map, importDataVO.getDisease(), klRule.getId(), 100, groupType);
                        }
                        if (StringUtil.isNotBlank(importDataVO.getPacsAll())) {
                            groupType = analyDataDealSimple(map, importDataVO.getPacsAll(), klRule.getId(), 112, groupType);
                        }
                    }
                }
            }
        }
        log.info("高危手术" + opt.size());
    }

    private void drugHighRisk(Map<String, String> mapPath, Map<String, KlConcept> map) {
        MultipartFile file = null;
        file = testFacade.getMulFileByPath(mapPath.get("【高危药品】"));
        List<ImportDataVO> data = ExcelUtils.importExcel(file, 0, 1, ImportDataVO.class);
        List<String> drugs = new ArrayList<>();
        for (ImportDataVO importDataVO : data) {
            if (StringUtil.isNotBlank(importDataVO.getDrugLevel())
                    && StringUtil.isNotBlank(importDataVO.getDrugHighRisk())
                    && StringUtil.isNotBlank(importDataVO.getDrugForm())) {
                if (null != map.get(importDataVO.getDrugHighRisk() + "_101").getId()
                        && !drugs.contains(importDataVO.getDrugHighRisk().trim())) {
                    drugs.add(importDataVO.getDrugHighRisk().trim());
                    KlRule klRule = new KlRule();
                    klRule.setConceptId(map.get(importDataVO.getDrugHighRisk().trim() + "_101").getId());
                    klRule.setDescription("高危药品_" + importDataVO.getDrugHighRisk().trim());
                    klRule.setRuleType(2);
                    klRule.setMsg(importDataVO.getDrugLevel().trim());
                    klRule.setHasSubCond(1);
                    klRuleService.save(klRule);
                    KlRuleBase klRuleBase = new KlRuleBase();
                    klRuleBase.setType(1);
                    String drugForm = importDataVO.getDrugForm().trim();
                    if (drugForm.indexOf("(") > 0) {
                        drugForm = drugForm.substring(0, importDataVO.getDrugForm().indexOf("("));
                    }
                    klRuleBase.setConceptId(map.get(drugForm + "_102").getId());
                    klRuleBase.setDescription(drugForm);
                    klRuleBaseService.save(klRuleBase);
                    KlRuleCondition klRuleCondition = new KlRuleCondition();
                    klRuleCondition.setGroupType(1);
                    klRuleCondition.setRuleId(klRule.getId());
                    klRuleCondition.setRuleBaseId(klRuleBase.getId());
                    klRuleConditionService.save(klRuleCondition);
                }
            }
        }
        log.info("高危药品" + drugs.size());
    }

    private Integer analyDataDeal(Map<String, KlConcept> map, String str, Long ruleId, Integer type, Integer groupType) {
        return analyDataDeal(map, str, ruleId, type, type, groupType);
    }

    private Integer analyDataDeal(Map<String, KlConcept> map, String str, Long ruleId, Integer condType, Integer noCondType, Integer groupType) {
        KlRuleAnalyVO klRuleAnalyVO = analyData(str);
        return klRuleAnalyVODeal(klRuleAnalyVO, map, ruleId, condType, noCondType, groupType);

    }

    private Integer analyDataDealSimple(Map<String, KlConcept> map, String str, Long ruleId, Integer type, Integer groupType) {
        return analyDataDealSimple(map, str, ruleId, type, type, groupType);
    }

    private Integer analyDataDealSimple(Map<String, KlConcept> map, String str, Long ruleId, Integer condType, Integer noCondType, Integer groupType) {
        KlRuleAnalyVO klRuleAnalyVO = analyDataSimple(str);
        return klRuleAnalyVODeal(klRuleAnalyVO, map, ruleId, condType, noCondType, groupType);

    }

    private Integer klRuleAnalyVODeal(KlRuleAnalyVO klRuleAnalyVO, Map<String, KlConcept> map, Long ruleId, Integer condType, Integer noCondType, Integer groupType) {
        List<KlRuleBase> klRuleBaseList = new ArrayList<>();
        if (ListUtil.isNotEmpty(klRuleAnalyVO.getCondList())) {
            for (KlRuleConditionVO klRuleConditionVO : klRuleAnalyVO.getCondList()) {
                if (null != map.get(klRuleConditionVO.getName() + "_" + condType)) {
                    KlRuleBase klRuleBase = new KlRuleBase();
                    klRuleBase.setType(2);
                    klRuleBase.setConceptId(map.get(klRuleConditionVO.getName() + "_" + condType).getId());
                    klRuleBase.setDescription(klRuleConditionVO.getName()
                            + klRuleConditionVO.getOperator()
                            + klRuleConditionVO.getValue()
                            + " "
                            + klRuleConditionVO.getUnit());
                    if (operator_eq.contains(klRuleConditionVO.getOperator())) {
                        klRuleBase.setEqOperator("=");
                        klRuleBase.setEqValue(klRuleConditionVO.getValue());
                        klRuleBase.setEqUnit(klRuleConditionVO.getUnit());
                    } else if (operator_gt.contains(klRuleConditionVO.getOperator())) {
                        klRuleBase.setMinOperator(">");
                        klRuleBase.setMinValue(klRuleConditionVO.getValue());
                        klRuleBase.setMinUnit(klRuleConditionVO.getUnit());
                    } else if (operator_ge.contains(klRuleConditionVO.getOperator())) {
                        klRuleBase.setMinOperator(">=");
                        klRuleBase.setMinValue(klRuleConditionVO.getValue());
                        klRuleBase.setMinUnit(klRuleConditionVO.getUnit());
                    } else if (operator_lt.contains(klRuleConditionVO.getOperator())) {
                        klRuleBase.setMaxOperator("<");
                        klRuleBase.setMaxValue(klRuleConditionVO.getValue());
                        klRuleBase.setMaxUnit(klRuleConditionVO.getUnit());
                    } else if (operator_le.contains(klRuleConditionVO.getOperator())) {
                        klRuleBase.setMaxOperator("<=");
                        klRuleBase.setMaxValue(klRuleConditionVO.getValue());
                        klRuleBase.setMaxUnit(klRuleConditionVO.getUnit());
                    } else {
                        /*DO Nothing*/
                    }
                    klRuleBaseList.add(klRuleBase);
                }
            }
        }
        if (ListUtil.isNotEmpty(klRuleAnalyVO.getNoCondList())) {
            for (String noCond : klRuleAnalyVO.getNoCondList()) {
                if (null != map.get(noCond + "_" + noCondType)) {
                    KlRuleBase klRuleBase = new KlRuleBase();
                    klRuleBase.setType(1);
                    klRuleBase.setConceptId(map.get(noCond + "_" + noCondType).getId());
                    klRuleBase.setDescription(noCond);
                    klRuleBaseList.add(klRuleBase);
                }
            }
        }
        if (ListUtil.isNotEmpty(klRuleBaseList)) {
            klRuleBaseService.saveBatch(klRuleBaseList);
            List<KlRuleCondition> klRuleConditionList = new ArrayList<>();
            for (KlRuleBase klRuleBase : klRuleBaseList) {
                KlRuleCondition klRuleCondition = new KlRuleCondition();
                klRuleCondition.setGroupType(groupType++);
                klRuleCondition.setRuleId(ruleId);
                klRuleCondition.setRuleBaseId(klRuleBase.getId());
                klRuleConditionList.add(klRuleCondition);
            }
            klRuleConditionService.saveBatch(klRuleConditionList);
        }
        return groupType;
    }

    private static KlRuleAnalyVO analyDataSimple(String str) {
        KlRuleAnalyVO klRuleAnalyVO = new KlRuleAnalyVO();
        if (StringUtil.isNotBlank(str)) {
            List<String> list = Arrays.asList(str.trim().split("#"));
            klRuleAnalyVO.setNoCondList(list);
        }
        return klRuleAnalyVO;
    }

    private static KlRuleAnalyVO analyData(String str) {
        KlRuleAnalyVO klRuleAnalyVO = new KlRuleAnalyVO();
        if (StringUtil.isNotBlank(str)) {
            List<String> list = Arrays.asList(str.trim().split("，"));
            if (ListUtil.isNotEmpty(list)) {
                List<KlRuleConditionVO> condList = new ArrayList<>();
                List<String> noCondList = new ArrayList<>();
                for (String s : list) {
                    List<String> slist = Arrays.asList(s.trim().split(","));
                    if (slist.size() == 1) {
                        noCondList.add(slist.get(0));
                    } else if (slist.size() == 4) {
                        KlRuleConditionVO klRuleConditionVO = new KlRuleConditionVO();
                        klRuleConditionVO.setName(slist.get(0));
                        klRuleConditionVO.setOperator(slist.get(1));
                        klRuleConditionVO.setValue(slist.get(2));
                        klRuleConditionVO.setUnit(slist.get(3));
                        condList.add(klRuleConditionVO);
                    } else if (slist.size() == 3) {
                        KlRuleConditionVO klRuleConditionVO = new KlRuleConditionVO();
                        klRuleConditionVO.setName(slist.get(0));
                        klRuleConditionVO.setOperator(slist.get(1));
                        klRuleConditionVO.setValue(slist.get(2));
                        klRuleConditionVO.setUnit("");
                        condList.add(klRuleConditionVO);
                    } else if (slist.size() == 2) {
                        KlRuleConditionVO klRuleConditionVO = new KlRuleConditionVO();
                        klRuleConditionVO.setName(slist.get(0));
                        klRuleConditionVO.setOperator("=");
                        klRuleConditionVO.setValue(slist.get(1));
                        klRuleConditionVO.setUnit("");
                        condList.add(klRuleConditionVO);
                    } else {

                    }
                }
                klRuleAnalyVO.setCondList(condList);
                klRuleAnalyVO.setNoCondList(noCondList);
            }
        }
        return klRuleAnalyVO;
    }

    private void lisOtherValues(Map<String, String> mapPath, Map<String, KlConcept> map) {
        MultipartFile file = null;
        file = testFacade.getMulFileByPath(mapPath.get("【其他值提醒_化验】"));
        List<ImportDataVO> data = ExcelUtils.importExcel(file, 0, 1, ImportDataVO.class);
        for (ImportDataVO importDataVO : data) {
            if (null != map.get(importDataVO.getLisGBName() + "_108")) {
                KlRule klRule = new KlRule();
                klRule.setConceptId(map.get(importDataVO.getLisGBName() + "_108").getId());
                klRule.setDescription("其他值提醒_化验_" + importDataVO.getLisGBName().trim());
                klRule.setRuleType(4);
                klRule.setHasSubCond(1);
                klRuleService.save(klRule);
                if (StringUtil.isNotBlank(importDataVO.getLisGBName())
                        && StringUtil.isNotBlank(importDataVO.getSymbol())) {
                    KlRuleBase klRuleBase = new KlRuleBase();
                    klRuleBase.setConceptId(map.get(importDataVO.getLisGBName() + "_108").getId());
                    if (operator_lt.contains(importDataVO.getSymbol())) {
                        klRuleBase.setType(2);
                        klRuleBase.setMaxOperator("<");
                        klRuleBase.setMaxValue(importDataVO.getValue().toString());
                        if (StringUtil.isNotBlank(importDataVO.getUnit())) {
                            klRuleBase.setMaxUnit(importDataVO.getUnit().trim());
                        }
                    }
                    if (operator_gt.contains(importDataVO.getSymbol())) {
                        klRuleBase.setType(2);
                        klRuleBase.setMinOperator(">");
                        klRuleBase.setMinValue(importDataVO.getValue().toString());
                        if (StringUtil.isNotBlank(importDataVO.getUnit())) {
                            klRuleBase.setMinUnit(importDataVO.getUnit().trim());
                        }
                    }
                    klRuleBase.setDescription(importDataVO.getLisGBName() + importDataVO.getSymbol()
                            + importDataVO.getValue() + " " + importDataVO.getUnit());
                    klRuleBaseService.save(klRuleBase);
                    KlRuleCondition klRuleCondition = new KlRuleCondition();
                    klRuleCondition.setGroupType(1);
                    klRuleCondition.setRuleId(klRule.getId());
                    klRuleCondition.setRuleBaseId(klRuleBase.getId());
                    klRuleConditionService.save(klRuleCondition);
                }
                if (StringUtil.isNotBlank(importDataVO.getOtherTipNodeType())
                        && StringUtil.isNotBlank(importDataVO.getOtherTipNodeName())) {
                    KlRuleBase klRuleBase = new KlRuleBase();
                    klRuleBase.setType(1);
                    if (importDataVO.getOtherTipNodeType().equals("药品通用名称")) {
                        klRuleBase.setConceptId(map.get(importDataVO.getOtherTipNodeName() + "_101").getId());
                    } else if (importDataVO.getOtherTipNodeType().equals("医保疾病名称")) {
                        klRuleBase.setConceptId(map.get(importDataVO.getOtherTipNodeName() + "_100").getId());
                    } else if (importDataVO.getOtherTipNodeType().equals("禁忌人群")) {
                        klRuleBase.setConceptId(map.get(importDataVO.getOtherTipNodeName() + "_117").getId());
                    } else {
                        /*Do Nothing*/
                    }
                    klRuleBase.setDescription(importDataVO.getOtherTipNodeType() + "_" + importDataVO.getOtherTipNodeName());
                    klRuleBaseService.save(klRuleBase);
                    KlRuleCondition klRuleCondition = new KlRuleCondition();
                    klRuleCondition.setGroupType(1);
                    klRuleCondition.setRuleId(klRule.getId());
                    klRuleCondition.setRuleBaseId(klRuleBase.getId());
                    klRuleConditionService.save(klRuleCondition);
                }
            }
        }
    }

    private void pacsOtherValues(Map<String, String> mapPath, Map<String, KlConcept> map) {
        MultipartFile file = null;
        file = testFacade.getMulFileByPath(mapPath.get("【其他值提醒_辅检】"));
        List<ImportDataVO> data = ExcelUtils.importExcel(file, 0, 1, ImportDataVO.class);
        for (ImportDataVO importDataVO : data) {
            if (null != map.get(importDataVO.getPacsDesc() + "_112")) {
                KlRule klRule = new KlRule();
                klRule.setConceptId(map.get(importDataVO.getPacsDesc() + "_112").getId());
                klRule.setDescription("其他值提醒_辅检_" + importDataVO.getPacsDesc().trim());
                klRule.setRuleType(4);
                klRule.setHasSubCond(1);
                if (null != importDataVO.getAgeMax()
                        || null != importDataVO.getAgeMin()
                        || StringUtil.isNotBlank(importDataVO.getDisName())
                        || StringUtil.isNotBlank(importDataVO.getSexStr())
                        || StringUtil.isNotBlank(importDataVO.getPacsDescHas())
                        || StringUtil.isNotBlank(importDataVO.getPacsDescNotHas())) {
                    klRule.setHasSubCond(1);
                } else {
                    klRule.setHasSubCond(0);
                }
                if (StringUtil.isNotBlank(importDataVO.getPacsTips())) {
                    klRule.setMsg(importDataVO.getPacsTips());
                }
                klRuleService.save(klRule);
                if (klRule.getHasSubCond().equals(1)) {
                    if (null != importDataVO.getAgeMax() || null != importDataVO.getAgeMin()) {
                        KlRuleBase klRuleBase = new KlRuleBase();
                        klRuleBase.setConceptId(map.get("年龄_410").getId());
                        klRuleBase.setType(2);
                        klRuleBase.setDescription("年龄范围");
                        if (null != importDataVO.getAgeMax()) {
                            if (importDataVO.getAgeRange().equals(0)) {
                                klRuleBase.setMaxOperator("<=");
                                klRuleBase.setMaxValue(importDataVO.getAgeMax().toString());
                            } else {
                                klRuleBase.setMinOperator(">=");
                                klRuleBase.setMinValue(importDataVO.getAgeMax().toString());
                            }
                        }
                        if (null != importDataVO.getAgeMin()) {
                            if (importDataVO.getAgeRange().equals(0)) {
                                klRuleBase.setMinOperator(">=");
                                klRuleBase.setMinValue(importDataVO.getAgeMin().toString());
                            } else {
                                klRuleBase.setMaxOperator("<=");
                                klRuleBase.setMaxValue(importDataVO.getAgeMin().toString());
                            }
                        }
                        klRuleBaseService.save(klRuleBase);
                        KlRuleCondition klRuleCondition = new KlRuleCondition();
                        klRuleCondition.setGroupType(1);
                        klRuleCondition.setRuleId(klRule.getId());
                        klRuleCondition.setRuleBaseId(klRuleBase.getId());
                        klRuleConditionService.save(klRuleCondition);
                    }
                    if (StringUtil.isNotBlank(importDataVO.getDisName())) {
                        KlRuleBase klRuleBase = new KlRuleBase();
                        klRuleBase.setConceptId(map.get(importDataVO.getDisName().trim() + "_117").getId());
                        klRuleBase.setDescription("人群_" + importDataVO.getDisName().trim());
                        klRuleBase.setType(1);
                        klRuleBaseService.save(klRuleBase);
                        KlRuleCondition klRuleCondition = new KlRuleCondition();
                        klRuleCondition.setGroupType(1);
                        klRuleCondition.setRuleId(klRule.getId());
                        klRuleCondition.setRuleBaseId(klRuleBase.getId());
                        klRuleConditionService.save(klRuleCondition);
                    }
                    if (StringUtil.isNotBlank(importDataVO.getSexStr())) {
                        KlRuleBase klRuleBase = new KlRuleBase();
                        klRuleBase.setConceptId(map.get(importDataVO.getSexStr().trim() + "_116").getId());
                        klRuleBase.setDescription("性别_" + importDataVO.getSexStr().trim());
                        klRuleBase.setType(1);
                        klRuleBaseService.save(klRuleBase);
                        KlRuleCondition klRuleCondition = new KlRuleCondition();
                        klRuleCondition.setGroupType(1);
                        klRuleCondition.setRuleId(klRule.getId());
                        klRuleCondition.setRuleBaseId(klRuleBase.getId());
                        klRuleConditionService.save(klRuleCondition);
                    }
                    if (StringUtil.isNotBlank(importDataVO.getPacsDescHas())) {
                        KlRuleBase klRuleBase = new KlRuleBase();
                        klRuleBase.setConceptId(map.get(importDataVO.getPacsDescHas().trim() + "_112").getId());
                        klRuleBase.setDescription("检查结论有_" + importDataVO.getPacsDescHas().trim());
                        klRuleBase.setType(1);
                        klRuleBaseService.save(klRuleBase);
                        KlRuleCondition klRuleCondition = new KlRuleCondition();
                        klRuleCondition.setGroupType(1);
                        klRuleCondition.setRuleId(klRule.getId());
                        klRuleCondition.setRuleBaseId(klRuleBase.getId());
                        klRuleConditionService.save(klRuleCondition);
                    }
                    if (StringUtil.isNotBlank(importDataVO.getPacsDescNotHas())) {
                        KlRuleBase klRuleBase = new KlRuleBase();
                        klRuleBase.setConceptId(map.get(importDataVO.getPacsDescNotHas().trim() + "_112").getId());
                        klRuleBase.setDescription("检查结论无_" + importDataVO.getPacsDescNotHas().trim());
                        klRuleBase.setType(3);
                        klRuleBaseService.save(klRuleBase);
                        KlRuleCondition klRuleCondition = new KlRuleCondition();
                        klRuleCondition.setGroupType(1);
                        klRuleCondition.setRuleId(klRule.getId());
                        klRuleCondition.setRuleBaseId(klRuleBase.getId());
                        klRuleConditionService.save(klRuleCondition);
                    }
                }
            }

        }
    }

    private void transfusionOtherValues(Map<String, String> mapPath, Map<String, KlConcept> map) {
        MultipartFile file = null;
        file = testFacade.getMulFileByPath(mapPath.get("【其他值提醒_输血】"));
        List<ImportDataVO> data = ExcelUtils.importExcel(file, 0, 1, ImportDataVO.class);
        for (ImportDataVO importDataVO : data) {
            if (null != map.get(importDataVO.getItemName() + "_108")) {
                KlRule klRule = new KlRule();
                klRule.setConceptId(map.get(importDataVO.getItemName() + "_108").getId());
                klRule.setDescription("其他值提醒_输血_" + importDataVO.getItemName().trim());
                klRule.setRuleType(5);
                klRule.setHasSubCond(1);
                if (StringUtil.isNotBlank(importDataVO.getTransfusionType())) {
                    klRule.setMsg(importDataVO.getTransfusionType().replace("建议输注", ""));
                }
                klRuleService.save(klRule);
                if (StringUtil.isNotBlank(importDataVO.getItemName())
                        && StringUtil.isNotBlank(importDataVO.getSymbol())) {
                    KlRuleBase klRuleBase = new KlRuleBase();
                    klRuleBase.setConceptId(map.get(importDataVO.getItemName() + "_108").getId());
                    if (operator_lt.contains(importDataVO.getSymbol())) {
                        klRuleBase.setType(2);
                        klRuleBase.setMaxOperator("<");
                        klRuleBase.setMaxValue(importDataVO.getValue().toString());
                        if (StringUtil.isNotBlank(importDataVO.getUnit())) {
                            klRuleBase.setMaxUnit(importDataVO.getUnit().trim());
                        }
                    }
                    if (operator_gt.contains(importDataVO.getSymbol())) {
                        klRuleBase.setType(2);
                        klRuleBase.setMinOperator(">");
                        klRuleBase.setMinValue(importDataVO.getValue().toString());
                        if (StringUtil.isNotBlank(importDataVO.getUnit())) {
                            klRuleBase.setMinUnit(importDataVO.getUnit().trim());
                        }
                    }
                    if (StringUtil.isNotBlank(importDataVO.getUnit())) {
                        klRuleBase.setDescription(importDataVO.getItemName() + importDataVO.getSymbol()
                                + importDataVO.getValue() + " " + importDataVO.getUnit());
                    } else {
                        klRuleBase.setDescription(importDataVO.getItemName() + importDataVO.getSymbol()
                                + importDataVO.getValue() + " ");
                    }
                    klRuleBaseService.save(klRuleBase);
                    KlRuleCondition klRuleCondition = new KlRuleCondition();
                    klRuleCondition.setGroupType(1);
                    klRuleCondition.setRuleId(klRule.getId());
                    klRuleCondition.setRuleBaseId(klRuleBase.getId());
                    klRuleConditionService.save(klRuleCondition);
                }
                if (StringUtil.isNotBlank(importDataVO.getDisName())
                        || StringUtil.isNotBlank(importDataVO.getOperationName())) {
                    KlRuleBase klRuleBase = new KlRuleBase();
                    klRuleBase.setType(1);
                    if (StringUtil.isNotBlank(importDataVO.getDisName())) {
                        klRuleBase.setConceptId(map.get(importDataVO.getDisName() + "_100").getId());
                        klRuleBase.setDescription("疾病_" + importDataVO.getDisName());
                    }
                    if (StringUtil.isNotBlank(importDataVO.getOperationName())) {
                        klRuleBase.setConceptId(map.get(importDataVO.getOperationName() + "_106").getId());
                        klRuleBase.setDescription("操作和手术_" + importDataVO.getOperationName());
                    }
                    klRuleBaseService.save(klRuleBase);
                    KlRuleCondition klRuleCondition = new KlRuleCondition();
                    klRuleCondition.setGroupType(1);
                    klRuleCondition.setRuleId(klRule.getId());
                    klRuleCondition.setRuleBaseId(klRuleBase.getId());
                    klRuleConditionService.save(klRuleCondition);
                }
            }
        }
    }

    private void pacsReorder(Map<String, String> mapPath, Map<String, KlConcept> map) {
        MultipartFile file = null;
        file = testFacade.getMulFileByPath(mapPath.get("【检查结果与项目重复开立规则】"));
        List<ImportDataVO> data = ExcelUtils.importExcel(file, 0, 1, ImportDataVO.class);
        for (ImportDataVO importDataVO : data) {
            if (StringUtil.isNotBlank(importDataVO.getPacsName())
                    && StringUtil.isNotBlank(importDataVO.getNormalRule())
                    && StringUtil.isNotBlank(importDataVO.getRegex())) {
                if (null != map.get(importDataVO.getPacsName().trim() + "_109")
                        || null != map.get(importDataVO.getPacsName().trim() + "_110")) {
                    KlRule klRule = new KlRule();
                    if (null != map.get(importDataVO.getPacsName().trim() + "_109")) {
                        klRule.setConceptId(map.get(importDataVO.getPacsName().trim() + "_109").getId());
                    } else {
                        if (null != map.get(importDataVO.getPacsName().trim() + "_110")) {
                            klRule.setConceptId(map.get(importDataVO.getPacsName().trim() + "_110").getId());
                        }
                    }
                    klRule.setDescription("检查正常项重复开立_" + importDataVO.getPacsName().trim());
                    klRule.setRuleType(6);
                    klRule.setHasSubCond(1);
                    klRuleService.save(klRule);
                    KlRuleBase klRuleBase = new KlRuleBase();
                    klRuleBase.setType(6);
                    if (null != map.get(importDataVO.getPacsName().trim() + "_109")) {
                        klRuleBase.setConceptId(map.get(importDataVO.getPacsName().trim() + "_109").getId());
                    } else {
                        if (null != map.get(importDataVO.getPacsName().trim() + "_110")) {
                            klRuleBase.setConceptId(map.get(importDataVO.getPacsName().trim() + "_110").getId());
                        }
                    }
                    klRuleBase.setDescription(importDataVO.getNormalRule());
                    klRuleBase.setEqValue(importDataVO.getRegex());
                    klRuleBaseService.save(klRuleBase);
                    KlRuleCondition klRuleCondition = new KlRuleCondition();
                    klRuleCondition.setGroupType(1);
                    klRuleCondition.setRuleId(klRule.getId());
                    klRuleCondition.setRuleBaseId(klRuleBase.getId());
                    klRuleConditionService.save(klRuleCondition);
                }
            }
        }
    }

    public Map<String, Object> importStatic() {
        List<GraphConceptInfo> graphConceptInfos
                = graphConceptInfoFacade.list(new QueryWrapper<GraphConceptInfo>()
                .eq("is_deleted", IsDeleteEnum.N.getKey()));
        List<GraphConceptDetail> graphConceptDetails
                = graphConceptDetailFacade.list(new QueryWrapper<GraphConceptDetail>()
                .eq("is_deleted", IsDeleteEnum.N.getKey())
                .orderByAsc("concept_id", "order_no"));
        Map<Long, List<GraphConceptDetail>> graphConceptDetailMap = EntityUtil.makeEntityListMap(graphConceptDetails, "conceptId");
        //获取标准词库Map
        Map<String, KlConcept> conceptMap = getConceptMap();
        List<KlConceptStatic> klConceptStatics = new ArrayList<>();
        Map<Long, Long> graphIdMap = new HashMap<>();
        for (GraphConceptInfo graphConceptInfo : graphConceptInfos) {
            String key = "";
            switch (graphConceptInfo.getType()) {
                case "药品通用名称":
                    key = graphConceptInfo.getName() + "_101";
                    break;
                case "实验室检查名称":
                    key = graphConceptInfo.getName() + "_108";
                    break;
                case "实验室检查套餐名":
                    key = graphConceptInfo.getName() + "_107";
                    break;
                case "医保手术和操作名称":
                    key = graphConceptInfo.getName() + "_106";
                    break;
                case "辅助检查名称":
                    key = graphConceptInfo.getName() + "_109";
                    break;
                case "辅助检查子项目名称":
                    key = graphConceptInfo.getName() + "_110";
                    break;
                case "医保疾病名称":
                    key = graphConceptInfo.getName() + "_100";
                    break;
            }
            if (null != conceptMap.get(key)) {
                KlConceptStatic klConceptStatic = new KlConceptStatic();
                BeanUtil.copyProperties(graphConceptInfo, klConceptStatic);
                klConceptStatic.setConceptId(conceptMap.get(key).getId());
                klConceptStatics.add(klConceptStatic);
                graphIdMap.put(conceptMap.get(key).getId(), graphConceptInfo.getId());
            }
        }
        klConceptStaticService.saveBatch(klConceptStatics);
        List<KlConceptDetail> klConceptDetails = new ArrayList<>();
        log.info("设置静态信息明细开始");
        for (KlConceptStatic klConceptStatic : klConceptStatics) {
            List<GraphConceptDetail> graphConceptDetailList = graphConceptDetailMap.get(graphIdMap.get(klConceptStatic.getConceptId()));
            if (ListUtil.isNotEmpty(graphConceptDetailList)) {
                for (GraphConceptDetail graphConceptDetail : graphConceptDetailList) {
                    KlConceptDetail klConceptDetail = new KlConceptDetail();
                    BeanUtil.copyProperties(graphConceptDetail, klConceptDetail);
                    klConceptDetail.setConceptId(klConceptStatic.getConceptId());
                    klConceptDetails.add(klConceptDetail);
                }
            }
        }
        log.info("设置静态信息明细结束");
        klConceptDetailService.saveBatch(klConceptDetails);
        return null;
    }

    private Map<String, KlConcept> getConceptMap() {
        List<KlConcept> klConcepts
                = klConceptService.list(new QueryWrapper<KlConcept>()
                .eq("is_deleted", IsDeleteEnum.N.getKey())
        );
        Map<String, KlConcept> map
                = EntityUtil.makeEntityMapByKeys(klConcepts, "_", "libName", "libType");
        return map;
    }

    public static void main(String[] args) {
        //analyData("体温,＞,38.0,℃，舒张压,＞,120,mm/Hg，收缩压,＞,180,mm/Hg，舒张压,＜,50,mm/Hg，收缩压,＜,80,mm/Hg，心率,＞,120,次/分，心率,＜,60,次/分，昏迷，意识不清，意识模糊");
        analyData("血小板计数,＜,60,10^9/L，血红蛋白测定(Hb),＜,60,g/L，白细胞计数(WBC),＞,20,10^9/L，国际标准化比值(INR),＞,1.2，血浆凝血酶原时间测定(PT),＞,13,秒，乙型肝炎表面抗原测定(HBsAg)(定量),＞,0.05,IU/ml， 乙型肝炎e抗原测定(HBeAg)(定量),＞,1,S/CO，不加热血清反应素试验,阳性，人免疫缺陷病毒抗体测定(Anti-HIV),阳性，糖化血红蛋白测定,>,8.5,%，血葡萄糖测定,≥,10,mmol/L，钾测定,＞,5.5,mmol/l，钾测定,＜,3.0,mmol/l，血氧饱和度(SAT),<,90,%");
    }
}
