package com.diagbot.web;

import com.diagbot.dto.RespDTO;
import com.diagbot.facade.ExportFacade;
import com.diagbot.vo.TestAllVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;
import springfox.documentation.annotations.ApiIgnore;

import java.util.Map;

/**
 * @Description:
 * @author: gaodm
 * @time: 2021/1/21 9:37
 */
@RestController
@RequestMapping("/export")
@Api(value = "图谱数据迁移相关API", tags = { "图谱数据迁移相关API" })
@SuppressWarnings("unchecked")
public class ExportController {
    @Autowired
    private ExportFacade exportFacade;

    @ApiOperation(value = "图谱数据节点迁移[gaodm]",
            notes = "")
    @PostMapping("/gdbExportNode")
    public RespDTO<Boolean> gdbExportNode() {
        return RespDTO.onSuc(exportFacade.gdbExportNode());
    }

    @ApiOperation(value = "图谱数据关系迁移[gaodm]",
            notes = "")
    @PostMapping("/gdbExportRelation")
    public RespDTO<Boolean> gdbExportRelation() {
        return RespDTO.onSuc(exportFacade.gdbExportRelation());
    }

    @ApiOperation(value = "诊断依据从图谱导入[gaodm]",
            notes = "")
    @PostMapping("/importExcelGraphDB")
    public RespDTO<Map<String, Object>> importExcelGraphDB() {
        return RespDTO.onSuc(exportFacade.importExcelGraphDB());
    }

    @ApiOperation(value = "诊断依据导入[gaodm]",
            notes = "")
    @PostMapping("/diagnoseImport")
    @ApiIgnore
    @Deprecated
    public RespDTO<Map<String, Object>> diagnoseImport(@RequestParam("file") MultipartFile file) {
        return RespDTO.onSuc(exportFacade.importExcel(file));
    }

    @ApiOperation(value = "提示信息导入[gaodm]",
            notes = "")
    @PostMapping("/importExcelTip")
    public RespDTO<Map<String, Object>> importExcelTip(TestAllVO testAllVO) {
        return RespDTO.onSuc(exportFacade.importExcelTip(testAllVO));
    }

    @ApiOperation(value = "导入静态信息[gaodm]",
            notes = "")
    @PostMapping("/importStatic")
    public RespDTO<Map<String, Object>> importStatic() {
        return RespDTO.onSuc(exportFacade.importStatic());
    }
}
